//*****************************************************************************
//* Applet java couleur version 1.0 du 15.1.97                                *
//* Michel CASABIANCA (C) 1997                                                *
//* Utilisation libre pour tout usage non commercial                          *
//*****************************************************************************
import java.applet.Applet;
import java.awt.*;

public class couleur extends Applet
{
  ascenseurs Ascenseurs;
  textes Textes;
  Canvas Palette;
  Color Couleur;

  public void init()
  {
    Ascenseurs=new ascenseurs(this);
    Textes=new textes(this);
    Palette=new Canvas();
    Couleur=new Color(0,0,0);
    Palette.setBackground(Couleur);
		setBackground(Color.lightGray);
    setLayout(new GridLayout(1,3,5,5));
    add(Palette);
    add(Ascenseurs);
    add(Textes);
  }

  public void miseAJour(Object Lequel)
  {
    if(Lequel==Ascenseurs)
    {
      Couleur=new Color(Ascenseurs.Rouge.getValue(),
        Ascenseurs.Verte.getValue(),
        Ascenseurs.Bleue.getValue());
      Palette.setBackground(Couleur);
      Palette.repaint();
      Textes.Rouge.setText(Integer.toString(Ascenseurs.Rouge.getValue(),16));
      Textes.Verte.setText(Integer.toString(Ascenseurs.Verte.getValue(),16));
      Textes.Bleue.setText(Integer.toString(Ascenseurs.Bleue.getValue(),16));
    }
    else
    {
      try
      {
        Couleur=new Color(Integer.parseInt(Textes.Rouge.getText(),16),
          Integer.parseInt(Textes.Verte.getText(),16),
          Integer.parseInt(Textes.Bleue.getText(),16));
      }
      catch(NumberFormatException e)
      {
      }
      Palette.setBackground(Couleur);
      Palette.repaint();
      Ascenseurs.Rouge.setValue(Couleur.getRed());
      Ascenseurs.Verte.setValue(Couleur.getGreen());
      Ascenseurs.Bleue.setValue(Couleur.getBlue());
    }
  }

  public Insets insets()
  {
    return(new Insets(5,5,5,5));
  }

  public void paint(Graphics g)
  {
    Rectangle Rect=bounds();
    g.setColor(Color.black);
    g.drawRect(0,0,Rect.width-1,Rect.height-1);
  }
}

class ascenseurs extends Panel
{
  Scrollbar Rouge;
  Scrollbar Verte;
  Scrollbar Bleue;
  couleur Parent;

  ascenseurs(couleur Parent)
  {
    Rouge=new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);
    Verte=new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);
    Bleue=new Scrollbar(Scrollbar.HORIZONTAL,0,1,0,255);
    setLayout(new GridLayout(3,1,5,5));
    add(Rouge);
    add(Verte);
    add(Bleue);
    this.Parent=Parent;
  }

  public boolean handleEvent(Event evt)
  {
    if(evt.target instanceof Scrollbar)
    {
      Parent.miseAJour(this);
      return(true);
    }
    else return(false);
  }
}

class textes extends Panel
{
  TextField Rouge;
  TextField Verte;
  TextField Bleue;
  couleur Parent;

  textes(couleur Parent)
  {
    Rouge=new TextField("0",2);
    Verte=new TextField("0",2);
    Bleue=new TextField("0",2);
    setLayout(new GridLayout(3,1,5,5));
    add(Rouge);
    add(Verte);
    add(Bleue);
    this.Parent=Parent;
  }

  public boolean action(Event evt,Object arg)
  {
    if(evt.target instanceof TextField)
    {
      try
      {
        Integer.parseInt(Rouge.getText(),16);
      }
      catch(NumberFormatException e)
      {
        Rouge.setText("0");
      }
      try
      {
        Integer.parseInt(Verte.getText(),16);
      }
      catch(NumberFormatException e)
      {
        Verte.setText("0");
      }
      try
      {
        Integer.parseInt(Bleue.getText(),16);
      }
      catch(NumberFormatException e)
      {
        Bleue.setText("0");
      }
      Parent.miseAJour(this);
      return(true);
    }
    else return(false);
  }
}

